this post was submitted on 06 Dec 2024
26 points (96.4% liked)

Advent Of Code

920 readers
4 users here now

An unofficial home for the advent of code community on programming.dev!

Advent of Code is an annual Advent calendar of small programming puzzles for a variety of skill sets and skill levels that can be solved in any programming language you like.

AoC 2024

Solution Threads

M T W T F S S
1
2 3 4 5 6 7 8
9 10 11 12 13 14 15
16 17 18 19 20 21 22
23 24 25

Rules/Guidelines

Relevant Communities

Relevant Links

Credits

Icon base by Lorc under CC BY 3.0 with modifications to add a gradient

console.log('Hello World')

founded 1 year ago
MODERATORS
 

Day 6: Guard Gallivant

Megathread guidelines

  • Keep top level comments as only solutions, if you want to say something other than a solution put it in a new post. (replies to comments can be whatever)
  • You can send code in code blocks by using three backticks, the code, and then three backticks or use something such as https://topaz.github.io/paste/ if you prefer sending it through a URL

FAQ

you are viewing a single comment's thread
view the rest of the comments
[–] Leavingoldhabits 3 points 4 weeks ago* (last edited 4 weeks ago) (9 children)

Rust

This one was the first real think for this year, but I ended up brute forcing it, placing a β€˜#’ in every position and checking. part 2 runs in about ~~380ms~~ 78ms (after reducing the amount β€˜#’-placements to only where the guard walks) on my 2011 core i-7, so I’m happy, even though it feels like I could have been smarter.

Part 1 Part 2

[–] [email protected] 2 points 4 weeks ago* (last edited 4 weeks ago) (8 children)

I am doing the same principle brute force but it takes ~7 seconds oO

Is using a HashSet<(Pos, Dir)> for the loop detection so expensive? My CPU shouldn't be THAT bad..

Part one around 7ms.

Also curious that i have not seen someone mention a more efficient approach, there gotta be one?

[–] Leavingoldhabits 2 points 4 weeks ago* (last edited 4 weeks ago) (1 children)

I’d like to see your solution in total. I’m not too familiar with the nuts and bolts, but hash set is quite a bit more expensive than a simple vector, there’s a bunch of overhead incurred when executing the hashing and placing of the data, and when repeating a few thousand times it sure adds up. My part one hovers around 600 microseconds.

[–] [email protected] 2 points 4 weeks ago

I’d like to see your solution in total.

I set it up a bit like a game, https://pastebin.com/FGA6E7fA

My part one hovers around 600 microseconds.

Ohhh, that says my part 1 is slow already, i was sure my approach for 2 was the problem. Good to know!

load more comments (6 replies)
load more comments (6 replies)